; Assembly Header File
; Created 06/07/2003, 13:04:41
;Projet : MicroShell
;Auteur : Matthieu Gallet
;Date : 01/07/03
;Langage : 68000
;Type : shell
;Plate-formes : V200,TI-92Plus,TI-89
; intgrer dans un TSR
;rev 0
my_tsr:
;<- a4 event
;<- a5 ptr vers jumptable
;<- a6 ptr vers tsr data
 lea     tsr_data(pc),a6
 
;d'abord quelques EVENTS qu'on doit toujours grer
 cmpi.w  #UTSR_ABOUT,(a4)
 bne     \about
 move.w  task_id(pc),d0
 cmp.w   2(a4),d0
 bne     \about
 lea     about_str(pc),a0
 move.l  a0,8(a4)
\about:
 cmp.w   #UTSR_RELOAD,(a4)
 beq     \reload
; bsr     _shl_reload_globals
\reload:

 cmpi.w  #UTSR_CAN_DELETE,(a4)
 bne     \candelete
 btst.b  #USHL_EXECUTE,Flags-OO(a6);teste pour voir si un programme n'est pas en cours d'utilisation
 beq     \candelete
 clr.w   8(a4)
 pea     erreur_delete_str(pc)
 move.l  920(a5),a0;ST_msg
 jsr     (a0)
 addq.l  #$4,a7

\candelete:


;on va faire un petit test pour voir si oui ou non on est dans une bote de dialogue
 move.l  792(a5),a0;EV_captureEvents
 move.l  2(a0),a0
 move.l  (a0),d0
 cmp.w   #CM_ACTIVATE,(a4)
 bne     \skip_currhandler
 move.l  d0,CurrHandler-OO(a6)
\skip_currhandler:
 bclr.b  #DIALOG_BOX,Flags-OO(a6)
 cmp.l   CurrHandler-OO(a6),d0
 beq     \skip_dialog_box
 bset.b  #DIALOG_BOX,Flags-OO(a6)
\skip_dialog_box:

;d'abord on gre la touche QUIT et les kbdprgm

 move.l  8(a4),d0
 cmpi.w  #CM_KEYPRESS,(a4)
 bne     \keypress
 cmpi.w  #$2031,d0;<> + 1
 blt     \kbdprgm
 cmpi.w  #$2039,d0;<> + 9
 ble     _execute_kbdprgm
\kbdprgm:
 cmpi.w  #$210C,d0;<> + F1
 blt     \kbdfunc
 cmpi.w  #$2113,d0;<> + F8
 ble     _execute_kbdfunc
\kbdfunc:
 cmpi.w  #$1108,d0;2nd + ESC
 bne     \keypress
 move.l  4428(a5),a0;EV_appB
 cmpi.w  #AP_NULL,(a0); = APP_NONE ?
 bne     \keypress
 move.w  #$2051,10(a4);<>+W
\keypress:


;aprs on s'occupe du reste
 move.l  4468(a5),a0;EV_runningApp
 move.w  (a0),d0

 cmp.w   DesktopID-OO(a6),d0;On regarde si on est bien dans le desktop
 bne     _shl_end
 btst.b  #DIALOG_BOX,Flags-OO(a6);on regarde si on n'est pas dans une Dialog Box
 bne     _shl_end

;on va vrifier si MicroShl doit tre activ
 cmp.w   #CM_WPAINT,(a4)
 bne     \wpaint
; on doit redessiner l'cran aprs que le TIOS a redessin l'cran
; comme a, c'est lui qui redessine presque tout
; => on doit sauvegarder l'event
 bsr     _desktop_handle_f3;on vrifie que F3 a un handle avec UNE app dedans 
 move.l  DataDesktop-OO(a6),a0
 bclr.b  #USHL_ACTIVATED,Flags-OO(a6)
 cmp.w   #2,162(a0);est-ce que c'est le folder slectionn ?
 bne     _shl_end
 bset.b  #USHL_ACTIVATED,Flags-OO(a6)
 move.w  #CM_WPAINT,Event-OO(a6);faudrait pas oublier de redessiner l'cran aprs
 bra     _shl_end
 
\wpaint:
 move.l  8(a4),d5
 btst.b  #USHL_ACTIVATED,Flags-OO(a6);on regarde si MicroShl est activ
 beq     _shl_end
;Oui, MicroShl est activ
_shl_activated:
 cmp.w   #CM_WPAINT,Event-OO(a6)
 beq     _shl_activated_paint
 cmp.w   #CM_MENU_PASTE,(a4)
 beq     _shl_end_700_2
 cmp.w   #CM_STRING,(a4)
 beq     _shl_end_700_2
 cmp.w   #CM_KEYPRESS,(a4)
 bne     _shl_activated_keypress
 bsr     draw_rect
 cmp.w   #268,d5
 beq     _shl_activated_menu
 cmp.w   #270,d5
 beq     _shl_activated_select
 cmp.w   #KEY_DOWN,d5
 beq     _shl_activated_bas
 cmp.w   #KEY_RIGHT,d5
 beq     _shl_activated_droite
 cmp.w   #KEY_LEFT,d5
 beq     _shl_activated_gauche
 cmp.w   #KEY_UP,d5
 beq     _shl_activated_haut
 cmp.w   #KEY_ESC,d5
 beq     keypress_esc
 cmp.w   #KEY_ENTER,d5
 beq     keypress_enter
 lea     data_shortcuts(pc),a0
 move.w  (a0)+,d0
\loop:
 cmp.w   (a0)+,d5
 beq     _shl_execute_shortcut
 addq.l  #2,a0
 dbra    d0,\loop
 cmp.w   #255,d5
 ble     keypress_letter
 bsr     draw_rect
 bra     _shl_end_1
_shl_activated_keypress:
_shl_end_1:
_shl_end:
 rts
_shl_end_700:
 move.w  #CM_IDLE,(a4)
 bsr     affich_info
 bsr     affich_fleches
 bra     draw_rect
_shl_end_700_2:
 move.w  #CM_IDLE,(a4)
 rts

;excution des kbdfunc
_execute_kbdfunc:
 subi.w  #$20DB,d0
 lea     _kbdfunc_symname(pc),a0
 bra     _execute_kbdprgm_kbdfunc
;excution des kbdprgm
_execute_kbdprgm:
 subi.w  #$2000,d0
 lea     _kbdprgm_symname(pc),a0
_execute_kbdprgm_kbdfunc:
 move.b  d0,-1(a0)
 move.l  a0,-(a7)
 move.l  388(a5),a0
 jsr     (a0)
 addq.l  #$4,a7
 tst.w   d0
 beq     _shl_end
 move.l  d0,-(a7)
 move.l  484(a5),a0
 jsr     (a0)
 addq.l  #$4,a7
 move.w  12(a0),d0
_execute_cmd0:
 bsr     execute
 move.w  #CM_IDLE,(a4)
 bclr.b  #3,Flags-OO(a6)
 bne     \skip
 move.w  #CM_WPAINT,(a4)
 move.w  #CM_WPAINT,Event-OO(a6);faudrait pas oublier de redessiner l'cran aprs
\skip:
 rts


keypress_letter:
;<- d5.w est la touche appuye
 move.w  NumVar-OO(a6),d0
 beq     _shl_end_700_2
 subq.w  #1,d0
 cmp.w   Abs-OO(a6),d0
 ble     keypress_letter_raz
 bsr     deref_variable
 move.w  NumVar-OO(a6),d0
 cmp.b   14(a0),d5
 blt     keypress_letter_raz
 addq.w  #1,Abs-OO(a6)
 lea     14(a0),a0
 bra     keypress_letter_loop
keypress_letter_raz:
 clr.w   Abs-OO(a6)
 bsr     deref_variable
 move.w  NumVar-OO(a6),d0
keypress_letter_loop:
 cmp.w   Abs-OO(a6),d0
 beq     keypress_letter_found
 cmp.b   (a0),d5
 ble     keypress_letter_found
 addq.w  #1,Abs-OO(a6)
 lea     14(a0),a0
 bra     keypress_letter_loop
keypress_letter_found:
 move.w  Abs-OO(a6),d0
 divu.w  #line_width,d0
 cmp.w   #column_height-1,d0
 ble     \skip
 move.w  #column_height-1,d0;; pas un moveq !!!
\skip:
 move.l  d0,Col-OO(a6)
 move.w  #CM_IDLE,(a4)
 bra     _shl_not_activated
keypress_esc:
 move.w  HOME-OO(a6),d0
 cmp.w   cur_folder-OO(a6),d0
 beq     _shl_end_700
 move.l  PrevCol-OO(a6),d1
 move.l  d1,Col-OO(a6)
 move.w  PrevAbs-OO(a6),d1
 move.w  d1,Abs-OO(a6)
 move.w  d0,cur_folder-OO(a6)
 move.w  #CM_IDLE,(a4)
 bra     _shl_not_activated
keypress_enter:
 bsr     deref_variable
 move.w  12(a0),d0
 btst.b  #7,11(a0)
 beq     keypress_enter_file
;on sauvegarde les donnes pour pouvoir les restaurer
 move.l  Col-OO(a6),d1
 move.l  d1,PrevCol-OO(a6)
 move.w  Abs-OO(a6),d1
 move.w  d1,PrevAbs-OO(a6)
keypress_enter_0:
 move.w  #CM_IDLE,(a4)
 bra     _shl_load_folder
keypress_enter_file:
;l on va mettre tout le code pour excuter des programmes
 bsr     draw_rect
 bra     _execute_cmd0
; bsr     execute
; move.w  #CM_WPAINT,(a4)
; move.w  #CM_WPAINT,Event-OO(a6);faudrait pas oublier de redessiner l'cran aprs
; rts

_shl_execute_shortcut:
 move.w  (a0)+,d0
 bsr     _shl_activated_do_action
 move.w  #CM_IDLE,(a4)
 rts

_shl_activated_menu:
 bsr     draw_rect
 moveq   #0,d4
 clr.l   -(a7)
 clr.w   -(a7)
 move.l  276(a5),a0;PopupNew
 jsr     (a0)
 addq.l  #6,a7
 move.w  d0,d4
 beq     \error_mem
 moveq   #9,d3
 lea     popup_data(pc),a2
\loop:
 moveq   #0,d0
 move.w  (a2)+,d0
 bsr     xr_string
 clr.w   -(a7)
 move.l  a0,-(a7)
 move.w  #$FFFF,-(a7)
 move.w  d4,-(a7)
 move.l  272(a5),a0;PopupAddText
 jsr     (a0)
 lea     10(a7),a7
 tst.w   d0
 beq     \exit_mem
 dbra    d3,\loop
 bsr     \sub_268
 
 clr.w   -(a7)
 moveq   #$E,d0
 move.l  d0,-(a7)
 move.w  d4,-(a7)
 move.l  284(a5),a0;PopupDo
 jsr     (a0)
 addq.l  #8,a7
 bsr     \sub_268
 tst.w   d0
 beq     \exit_mem
 add.w   #C_BASE,d0
 bsr     _shl_activated_do_action
\error_mem:
\exit_mem:
 tst.w    d4
 beq.s    \skip
 move.w   d4,-(a7)
 movea.l  604(a5),a0;HeapFree
 jsr      (a0)
 addq.l   #2,a7

\skip:
 move.w  #CM_IDLE,(a4)
 rts
\sub_268:
 movem.l d0/d4,-(a7)
 moveq   #0,d0
 moveq   #0,d1
 move.w  #rect_268_x,d2
 move.w  #rect_268_y,d3
 moveq   #2,d4
 bsr     graphlib0000
 movem.l (a7)+,d0/d4
 rts

_shl_activated_do_action:
 move.w  d0,-(a7)
 move.w  Abs-OO(a6),-(a7)
 move.w  cur_folder-OO(a6),-(a7)
 ifeq RAM_lib
 bsr     microshl@0000
 addq.l  #6,a7
 endc
 ifne RAM_lib
 clr.l   -(a7)
 pea     ushlib_str(pc)
 jsr     kernel::LibsExec
 lea     14(a7),a7
 endc
 move.w  #CM_WPAINT,Event-OO(a6)
 rts
ushlib_str:
 dc.b   'microshl',0
 even

_shl_activated_select:
 bsr     deref_variable
 bchg.b  #5,11(a0)
 move.w  Col-OO(a6),d4
 move.w  Line-OO(a6),d5
 bsr     draw_selection
 bsr     draw_rect
 move.w  #CM_IDLE,(a4)
 bra     _shl_end_1

_shl_activated_paint:
 move.w  HOME-OO(a6),d0
 cmp.w   cur_folder-OO(a6),d0;on est dans le HOME
 beq     _shl_not_activated
 bsr     deref
 addq.l  #2,a0
 move.w  (a0)+,d2
 beq     _shl_load_folder
 move.w  cur_folder-OO(a6),d1
 beq     _shl_load_folder
 subq.w  #$1,d2
_est_folder_loop:
 cmp.w   12(a0),d1
 beq     _shl_not_activated
 lea     14(a0),a0
 dbra    d2,_est_folder_loop
_shl_load_folder:
;<- d0.w handle du folder  charger
 clr.l   Col-OO(a6)
 clr.w   Abs-OO(a6)
 move.w  d0,cur_folder-OO(a6)
_shl_not_activated:
 clr.w   Event-OO(a6)
 move.w  cur_folder-OO(a6),d0
 bsr     deref
 move.w  2(a0),d0;nbr de variables
 move.w  d0,NumVar-OO(a6)
 cmp.w   Abs-OO(a6),d0;Abs-OO(a6)=n de ligne
 bgt     initialise_end
 clr.l   Col-OO(a6)
 clr.w   Abs-OO(a6)
initialise_end:
 bsr     shl_redraw
 bsr     affich_info
 bra     draw_rect;au lieu d'un bsr ***, rts
 

_shl_activated_haut:
 lea     Abs-OO(a6),a0
 cmp.w   #line_width-1,(a0)
 ble     _shl_end_700
 sub.w   #line_width,(a0)
 lea     Line-OO(a6),a0 
 tst.w   (a0)
 beq     _shl_activated_droite_0
 subq.w  #1,(a0)
 bra     _shl_end_700
_shl_activated_bas:
 move.w  Abs-OO(a6),d0
 add.w   #line_width,d0
 cmp.w   NumVar-OO(a6),d0
 bge     _shl_end_700
 move.w  d0,Abs-OO(a6)
 lea     Line-OO(a6),a0
 addq.w  #1,(a0)
 cmp.w   #column_height,(a0)
 bne     _shl_end_700
 bra     _shl_activated_droite_1
_shl_activated_droite:
 move.w  Abs-OO(a6),d0
 addq.w  #1,d0
 cmp.w   NumVar-OO(a6),d0
 beq     _shl_end_700
 move.w  d0,Abs-OO(a6)
 lea     Col-OO(a6),a0
 add.w   #1,(a0)
 cmp.w   #line_width,(a0)
 bne     _shl_end_700
 clr.w   (a0)+
 add.w   #1,(a0)
 cmp.w   #column_height,(a0)
 bne     _shl_end_700
_shl_activated_droite_1:
 move.w  #column_height-1,(a0)
_shl_activated_droite_0:
 bsr     shl_redraw
 bra     _shl_end_700
_shl_activated_gauche:
 tst.w   Abs-OO(a6)
 beq     _shl_end_700
 move.w  Abs-OO(a6),d0
 beq     _shl_end_700
 sub.w   #1,d0
 move.w  d0,Abs-OO(a6)
 lea     Col-OO(a6),a0
 tst.w   (a0)
 bne     _shl_activated_gauche_1
_shl_activated_gauche_0:
 move.w  #line_width-1,(a0)+
 tst.w   (a0)
 beq     _shl_activated_droite_0
_shl_activated_gauche_1:
 subq.w  #1,(a0)
 bra     _shl_end_700
 
 include "subfunc.h"